/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is cookiebutton.
 *
 * The Initial Developer of the Original Code is
 * Pang Lih Wuei (basic@mozdev.org).
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

window.addEventListener("load", function (e) 
{
	var doc             = this.document;
	var classes         = Components.classes;
	var ifaces          = Components.interfaces;
	var subscriptLoader = classes["@mozilla.org/moz/jssubscript-loader;1"] .getService(ifaces.mozIJSSubScriptLoader);

	// auto platform detection
	var context = {};
	try{subscriptLoader.loadSubScript("chrome://cookiebutton-platform/content/overlay.js", context);}catch(e){}
	var autoplatform = 'autoplatform' in context ? context.autoplatform : 'unix';

	function disableElement()
	{
		var ele = this.element;
		ele.removeAttribute("value");
		ele.setAttribute("disabled", "true");
	}

	function enableElement(location)
	{
		var ele = this.element;
		value = this.getPermission(location);
		this.tooltip.label = this.labelGenerator(value, location);
		ele.setAttribute("value", value);
		ele.removeAttribute("disabled");
	}
	

	// load cookieperm object
	context = {};
	subscriptLoader.loadSubScript("chrome://cookiebutton/content/cookieperm.js", context);
	cookiePermission = context.cookiePermission;
	cookiePermission.element = doc.getElementById("cookie-perm-button-broadcaster");
	cookiePermission.tooltip = doc.getElementById("cookie-perm-button-tooltip");
	cookiePermission.init(doc, "button", disableElement, enableElement);
	var buttonPrefObserver =
	{
		_cookie        : cookiePermission,
		observe        : function (subject, topic, data)
		{
		},
		QueryInterface : function (aIID) 
		{
			if (aIID.equals(Components.interfaces.nsIObserver) ||
				aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
				aIID.equals(Components.interfaces.nsISupports))
					return this;
			throw Components.results.NS_NOINTERFACE;
		},
		_update        : function ()
		{
			var cookie = this._cookie;
			var branch = cookie.extPrefBranch;
			cookie.element.className = "toolbarbutton-1" + (branch.getBoolPref("always-hide-text") ? " hide-text" : "");
		}
	};
	buttonPrefObserver._update();
	cookiePermission.extPrefBranch.addObserver("always-hide-text", buttonPrefObserver, true);
	doc.getElementById("cookie-perm-button-broadcaster")._cookiePermission = cookiePermission;
}, false);
